;--------------------------------------------------------------------------------
;	Periferie DS1 - kotel, zdroj
;	DS adresa 00000001
;
;	16F876A / 20MHz			
;	vse OFF, osc. HS, bez preruseni
;
;	02/2016 Milan rajer
;--------------------------------------------------------------------------------
;
;                             --------\/--------
;                     RESET  -|MCLR     PGD/RB7|-  ICSP
;                       AKU  -|RA0/AN0  PGC/RB6|-  ICSP
;                            -|RA1/AN1      RB5|-  LED
;                            -|RA2/AN2      RB4|-  
;                            -|RA3/AN3  PGM/RB3|-  
;                            -|RA4          RB2|-  
;                            -|RA5/AN4      RB1|-  
;                        0V  -|Vss      INT/RB0|-  
;       Krystal 20,00 Mhz /  -|osc1         Vdd|-  +5V
;                         \  -|osc2         Vss|-  0V
;                       BUS  -|RC0       Rx/RC7|-  
;                        T1  -|RC1       Tx/RC6|-  
;                        T2  -|RC2          RC5|-  
;                            -|RC3/SCL  SDA/RC4|-  
;                             ------------------
;
;--------------------------------------------------------------------------------

	LIST P=16F876, R=DEC
	INCLUDE <P16F876.INC>

;-------------------------------
;	Nastaveni pojistek
;-------------------------------

	org	0x2007		;adresa nastaveni pojistek pro PIC16F876 a PIC16F877
	dw _BODEN_OFF & _CP_OFF & _WRT_ENABLE_OFF & _PWRTE_OFF & _WDT_OFF &_HS_OSC &_DEBUG_OFF & _CPD_OFF & _LVP_OFF

;-------------------------------
;	Nastaveni dat v EEPROM
;-------------------------------

	org	0x2100		;tabulka v pameti EEPROM (256 bytu)
;		----------------------------------------------
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
;		----------------------------------------------
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
;		----------------------------------------------
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
;		----------------------------------------------
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
;		----------------------------------------------

;--------------------------------------------------------------------------------
;	Nastaveni parametru
;-------------------------------
W	equ	0
F	equ	1
;--------------------------------------------------------------------------------
;	Definice registru, bitu a pinu
;-------------------------------
SYS	equ	0x20
;-----------------------------------
;|   |   |   |   |   |   |   | TMP |
;-----------------------------------
#define	TMP	SYS,0
;       ------------------------
TMP1	equ	0x21		;pomocny registr
TMP2	equ	0x22		;pomocny registr
TMP3	equ	0x23		;pomocny registr
TMP4	equ	0x24		;pomocny registr
TMP5	equ	0x25		;pomocny registr
;       ------------------------
CEK1	equ	0x26		;casova smycka
CEK2	equ	0x27		;casova smycka
CEK3	equ	0x28		;casova smycka
;       ------------------------
DAT	equ	0x29		;datovy registr
;       ------------------------
BCD	equ	0x2A		;cislo v BCD kodu
BCDD	equ	0x2B		;desitky v BCD kodu
BCDJ	equ	0x2C		;jednotky v BCD kodu
;-------------------------------
;	Pracovni registry DS18B20
;-------------------------------
DES	equ	0x30
;       ------------------------
LSB	equ	0x34
MSB	equ	0x35
TH	equ	0x36
TL	equ	0x37
CON	equ	0x38
RE01	equ	0x39
RE02	equ	0x3A
RE03	equ	0x3B
CRC	equ	0x3C
;-------------------------------
;	Teplota T1
;-------------------------------
T1DE	equ	0x40		;T1 desitky
T1JE	equ	0x41		;T1 jednotky
T1DT	equ	0x42		;T1 desetiny
;-------------------------------
;	Teplota T2
;-------------------------------
T2DE	equ	0x50		;T2 desitky
T2JE	equ	0x51		;T2 jednotky
T2DT	equ	0x52		;T2 desetiny
;-------------------------------
;	Akumulator
;-------------------------------
AKUDE	equ	0x60		;akumulator desitky
AKUJE	equ	0x61		;akumulator jednotky
AKUDT	equ	0x62		;akumulator desetiny
;-------------------------------
;	Sbernice
;-------------------------------
#define	BUS	PORTC,0		;sbernice
#define	BUS_T	TRISC,0		;tris registr sbernice
;-------------------------------
;	Periferie
;-------------------------------
#define	AKU	PORTA,0		;akumulator
#define	T1	PORTC,1		;teplotni cidlo 1
#define	T1_T	TRISC,1		;tris registr cidla 1
#define	T2	PORTC,2		;teplotni cidlo 2
#define	T2_T	TRISC,2		;tris registr cidla 2
#define	LED	PORTB,5		;LED dioda (nyni neaktivni)
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;	Zacatek behu programu
;-------------------------------
	org	0x0000
	goto	initial
;--------------------------------------------------------------------------------
;	Knihovny
;-------------------------------
	#include	<piclib_bus_v2.inc>		;komunikace po sbernici
	#include	<piclib_2xDS18B20_v3.inc>	;komunikace s 2x DS18B20
	#include	<piclib_adc_v2.inc>		;obsluha AD prevodniku
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;	Inicializace po zapnuti
;-------------------------------
;-------------------------------
;	nastaveni portu
;-------------------------------
initial	bcf	STATUS,RP0	;banka 0
	bcf	STATUS,RP1
;-------------------------------
	clrf	PORTA		;vymazani vsech portu
	clrf	PORTB
	clrf	PORTC
;       ------------------------
	movlw	b'01000001'	;A/D prevodnik
;		  01------	;Fosc/8
;		  --000---	;aktivace AN0
;		  -----0--	;jeste nespoustet prevod
;		  -------1	;aktivace prevodniku, jeste neprevadi
	movwf	ADCON0
;-------------------------------
	bsf	STATUS,RP0	;banka 1
	bcf	STATUS,RP1
;-------------------------------
	movlw	b'111111'
	movwf	TRISA		;port A vstupni/vystupni
	movlw	b'11111111'
	movwf	TRISB		;port B vstupni/vystupni
	movlw	b'11111111'
	movwf	TRISC		;port C vstupni/vystupni
;       ------------------------
	movlw	b'00000101'	;A/D prevodnik
;		  0-------	;data zarovnat doleva
;		  ----0101	;AN0, AN1 analog ostatni digital, +Vref=RA3, -Vref=Vss
	movwf	ADCON1
;       ------------------------
	bcf	STATUS,RP0	;banka 0
	bcf	STATUS,RP1
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;
;	*****	*****	*****	****	*****
;	*	  *	*   *	*   *	  *
;	*****	  *	***** 	****	  *
;	    *	  *	*   *	*  *	  *
;	*****	  *	*   *	*   *	  *
;
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
start	clrf	T1DE		;vynuluj merene hodnoty
	clrf	T1JE		;
	clrf	T1DT		;
;       ------------------------
	clrf	T2DE		;
	clrf	T2JE		;
	clrf	T2DT		;
;       ------------------------
	clrf	AKUDE		;
	clrf	AKUJE		;
	clrf	AKUDT		;
;-------------------------------
;	Mereni teplot T1 a T2 a konverze napeti akumulatoru
;-------------------------------
mereni	call	t1_mer		;zmer T1
	call	t2_mer		;zmer T2
;       ------------------------
	call	c0s8		;pockej 0,8s na dokonceni procesu (>0,7s)
;       ------------------------
	call	t1_cti		;cti T1
	call	t2_cti		;cti T2
;       ------------------------
	call	adcAN0		;AD prevod AN0
	call	napeti		;prevod na napeti
;-------------------------------
;	Neustale probihajici detekce reset impulsu
;-------------------------------
rutina	btfsc	BUS		;cekej na log 0
	goto	rutina
;-------------------------------
	movlw	.150		;test delky impulsu log 0 po dobu 120us
        movwf	CEK1
;       ------------------------
	btfsc	BUS		;pokud je impuls kratsi, vrat se na rutinu
	goto	rutina
;       ------------------------
	decfsz	CEK1,1
        goto	$-3		;..jinak pokracuj
;-------------------------------
	movlw	.11		;cekej max 1200us na konec reset impulsu (log 1)
        movwf	CEK2
rut12   movlw	.135
        movwf	CEK1
;       ------------------------
rut11	btfsc	BUS		;pokud behem testu prejde BUS do log 1..
	goto	nac_adr		;..pokracuj v prijmu
;       ------------------------
	decfsz	CEK1,1
        goto	rut11
        decfsz	CEK2,1
        goto	rut12		;pokud se log 1 neobevi, vrat se na rutinu
	goto	rutina
;-------------------------------
;	Prijem adresy periferie (00000001)
;-------------------------------
nac_adr	call	bus_dat		;precte byte ze sbernice
;       ------------------------
	movlw	b'00000001'	;je tazano toto zarizeni?
	subwf	DAT,W
	btfss	STATUS,Z	;pokud ne, vrat se na rutinu, jinak pokracuj
	goto	rutina
;-------------------------------
;	Vyslani dat na sbernici
;-------------------------------
vysli	call	bus_rw		;prodleva pred zacatkem vysilani
;       ------------------------
	movf	T1DE,W		;T1
	call	w_bus
	movf	T1JE,W
	call	w_bus
	movf	T1DT,W
	call	w_bus
;       ------------------------
	movf	T2DE,W		;T2
	call	w_bus
	movf	T2JE,W
	call	w_bus
	movf	T2DT,W
	call	w_bus
;       ------------------------
	movf	AKUDE,W		;AKU
	call	w_bus
	movf	AKUJE,W
	call	w_bus
	movf	AKUDT,W
	call	w_bus
;       ------------------------
	movlw	b'01010101'	;kontrolni byte
	call	w_bus
;       ------------------------
	goto	mereni		;po vyslani dat se vrat a proved nove mereni
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;	Prevod vysledku A/D prevodniku na napeti akumulatoru
;-------------------------------
napeti	movf	ADRESH,W
	movwf	TMP1
	movwf	TMP2
	movwf	TMP3
;	------------------------
	swapf	TMP1,F		;uprava registru desitky/jednotky
	swapf	TMP2,F
	movlw	0x0F
	andwf	TMP1,F
	andwf	TMP2,F
	andwf	TMP3,F
;	------------------------
	call	Ades		;prevod desitek
	movwf	AKUDE
;	------------------------
	call	Ajed		;prevod jednotek
	movwf	AKUJE
;	------------------------
	call	Adet		;prevod desetin
	movwf	AKUDT
;	------------------------
	return
;-------------------------------
Ades	movf	TMP1,F
	btfss	STATUS,Z
	goto	$+2	
	retlw	0x00		;0
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;1
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;2
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;3
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;4
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;5
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;6
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;7
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;8
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x00		;9
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;A
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;B
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;C
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;D
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;E
;	------------------------
	decfsz	TMP1,F
	goto	$+2	
	retlw	0x01		;F
;-------------------------------
Ajed	movf	TMP2,F
	btfss	STATUS,Z
	goto	$+2	
	retlw	0x00		;0
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x01		;1
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x02		;2
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x03		;3
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x04		;4
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x05		;5
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x06		;6
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x07		;7
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x08		;8
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x09		;9
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x00		;A
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x01		;B
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x02		;C
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x03		;D
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x04		;E
;	------------------------
	decfsz	TMP2,F
	goto	$+2	
	retlw	0x05		;F
;-------------------------------
Adet	movf	TMP3,F
	btfss	STATUS,Z
	goto	$+2	
	retlw	0x00		;0
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x00		;1
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x01		;2
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x02		;3
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x02		;4
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x03		;5
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x04		;6
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x04		;7
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x05		;8
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x06		;9
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x06		;A
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x07		;B
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x08		;C
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x08		;D
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x09		;E
;	------------------------
	decfsz	TMP3,F
	goto	$+2	
	retlw	0x09		;F
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;cekaci smycky
;-------------------------------
c0s8	movlw	.69  		;(30)
        movwf	CEK3
        movlw	.91		;(255)
        movwf	CEK2
        movlw	.211		;(255)
        movwf	CEK1
;       ------------------------
        decfsz	CEK1,F
        goto	$-1
        decfsz	CEK2,F
        goto	$-5
        decfsz	CEK3,F
        goto	$-9
;       ------------------------
	return
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;
;	*****	*****	*****	*****		  *
;	*   *	*   *	*	*		 **
;	*****	*****	*  ** 	***		  *
;	*	*   *	*   *	*		  *
;	*	*   *	*****	*****		 ***
;
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
	org	0x0800		;stranka 1
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;
;	*****	*****	*****	*****		*****
;	*   *	*   *	*	*		    *
;	*****	*****	*  ** 	***		*****
;	*	*   *	*   *	*		*
;	*	*   *	*****	*****		*****
;
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
	org	0x1000		;stranka 2
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
;
;	*****	*****	*****	*****		*****
;	*   *	*   *	*	*		    *
;	*****	*****	*  ** 	***		*****
;	*	*   *	*   *	*		    *
;	*	*   *	*****	*****		*****
;
;--------------------------------------------------------------------------------
;--------------------------------------------------------------------------------
	org	0x1800		;stranka 3
;--------------------------------------------------------------------------------
	end