;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;
;	Knihovna pro obsluhu A/D prevodniku
;
;	Procesor:	16F877A	
;	Rychlost:	-
;	Umisteni:	-
;
;	Autor:		Milan rajer, www.milansrajer.cz
;	Datum:		07/2015
;
;-------------------------------------------------------------------------------
;
;	call	adcANx		<- provede pevod A/D ze vstupu ANx
;	------------------------
;	ADRESH			<- prevedena data
;	ADRESL
;
;-------------------------------------------------------------------------------
;
;	Bity vyuzivane k AD konverzi musi byt nastaveny jako vstupni
;	------------------------------------------------------------
;
;	movlw	b'01000001'	;konfigurace AD prevodniku
;		  01------	;Fosc/8
;		  --000---	;aktivace AN0
;		  -----0--	;jeste nespoustet prevod
;		  -------1	;aktivace prevodniku, jeste neprevadi
;	movwf    ADCON0
;
;
;	bsf	STATUS,RP0	;banka 1
;	bcf	STATUS,RP1
;	movlw	b'00001110'	;nastaveni vstupu
;		  0-------	;data zarovnat doleva
;		  ----1110	;AN0 analog ostatni digital, +Vref=Vdd, -Vref=Vss
;	movwf    ADCON1
;	bsf	STATUS,RP0	;banka 0
;
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------	
adcAN0	bcf	ADCON0,5	;nastav AN0
	bcf	ADCON0,4
	bcf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN1	bcf	ADCON0,5	;nastav AN1
	bcf	ADCON0,4
	bsf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN2	bcf	ADCON0,5	;nastav AN2
	bsf	ADCON0,4
	bcf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN3	bcf	ADCON0,5	;nastav AN3
	bsf	ADCON0,4
	bsf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN4	bsf	ADCON0,5	;nastav AN4
	bcf	ADCON0,4
	bcf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN5	bsf	ADCON0,5	;nastav AN5
	bcf	ADCON0,4
	bsf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN6	bsf	ADCON0,5	;nastav AN6
	bsf	ADCON0,4
	bcf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------
adcAN7	bsf	ADCON0,5	;nastav AN7
	bsf	ADCON0,4
	bsf	ADCON0,3
;	------------------------
	call	startAD		;spust prevod
;	------------------------
	return
;-------------------------------------------------------------------------------
;	A/D konverze, vysledek v ADRESH, ADRESL
;-------------------------------
startAD	bsf      ADCON0,GO	;Start A/D konverze
;       ------------------------
	btfsc    ADCON0,GO	;cekani na dokonceni
	goto     $-1
;       ------------------------
	return
;-------------------------------------------------------------------------------